unit kicadmeu;

(*
  TODO: 
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, Buttons, Grids, ExtCtrls;

type
  TfmMain = class(TForm)
    pnTop: TPanel;
    pnGrid: TPanel;
    pnBot: TPanel;
    sgGrid: TStringGrid;
    pnSheet: TPanel;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    lFSheet: TEdit;
    Panel1: TPanel;
    Label2: TLabel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
	lFRef: TEdit;
    Panel2: TPanel;
    Label3: TLabel;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    lFPart: TEdit;
    Panel3: TPanel;
    Label4: TLabel;
    SpeedButton7: TSpeedButton;
	SpeedButton8: TSpeedButton;
    lfValue: TEdit;
    Panel4: TPanel;
    Label5: TLabel;
	SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    lfFootpr: TEdit;
    Panel5: TPanel;
	Label6: TLabel;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    lfUser: TEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    mmLog: TMemo;
    lCurrentFile: TLabel;
    lCurrentTitle: TLabel;
    tmRefresh: TTimer;
    edEdit: TEdit;
    Label8: TLabel;
    dlgOpen: TOpenDialog;
    Label9: TLabel;
    Edit1: TMenuItem;
    Selecteditcell1: TMenuItem;
    Copyfieldfrom1: TMenuItem;
    lCopyfrom: TLabel;
    Cancelcopyfrom1: TMenuItem;
    ckFPInvisible: TCheckBox;
	Label10: TLabel;
    lCompCount: TLabel;
	Label7: TLabel;
    procedure FormShow(Sender: TObject);
    procedure lfUserChange(Sender: TObject);
	procedure tmRefreshTimer(Sender: TObject);
	procedure SpeedButton12Click(Sender: TObject);
	procedure sgGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure edEditKeyPress(Sender: TObject; var Key: Char);
	procedure Open1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Exit1Click(Sender: TObject);
	procedure lFSheetKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
	procedure Save1Click(Sender: TObject);
	procedure sgGridKeyPress(Sender: TObject; var Key: Char);
	procedure Selecteditcell1Click(Sender: TObject);
	procedure Copyfieldfrom1Click(Sender: TObject);
	procedure sgGridMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
	procedure Cancelcopyfrom1Click(Sender: TObject);
    procedure lFSheetEnter(Sender: TObject);
    procedure Label1DblClick(Sender: TObject);
    procedure Label2DblClick(Sender: TObject);
    procedure Label3DblClick(Sender: TObject);
    procedure Label4DblClick(Sender: TObject);
    procedure Label5DblClick(Sender: TObject);
    procedure Label6DblClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
	{ Private declarations }
  public
	{ Public declarations }
	// copyfrom	: boolean;
	copycol,
	copyrow		: integer;
	copysel		: TGridRect;
	copytext	: string;
	procedure	RefreshGrid;
  end;

var
  fmMain: TfmMain;

implementation

uses aboutu;

{$R *.dfm}

type
  PKComponent	= ^TKComponent;
  TKComponent	= record
	ps			: PKComponent;
	sheetname	: string;
	reference	: string;		// R1, C5...
	part		: string;		// part name
	value		: string;		// 2K2, 100uF...
	Footpr		: string;		// footprint
	userfield	: string;
	included	: boolean;		// used to include it or not
	modified	: boolean;
	end;

  PKSheet		= ^TKSheet;
  TKSheet		= record
	ps			: PKSheet;
	sheetname	: string;		// titleof the sheet
	filename	: string;		// containing filename
	modified	: boolean;
	end;

var
  FSheet	: PKSheet = NIL;
  FComp		: PKComponent = NIL;
  SortMethod: integer = 2;


procedure loadsheet(fn, title: string);
var
  rfile		: TextFile;
  ln		: integer;
  st		: string;
  tmptit	: string;
  i,k		: integer;
  sht		: PKSheet;
  cmp		: PKComponent;

  procedure readaline;
  begin
	readln(rfile, st);
	inc(ln)
  end;

begin
  if not FileExists(fn) then begin
	Application.MessageBox(PChar('File not found '+fn),'KicadME: error reading sheet');
	exit
  end;

  fmMain.mmLog.Lines.add('Reading sheet '+fn);

  if title='<root>' then begin
	while FSheet<>NIL do begin
	  sht := FSheet;
	  FSheet := FSheet^.ps;
	  dispose(sht)
	end;

	while FComp<>NIL do begin
	  cmp := FComp;
	  FComp := FComp^.ps;
	  dispose(cmp)
	end
  end;

  new(sht);
  with sht^ do begin
	ps := FSheet;
	filename := fn;
	modified := false;
	sheetname := title
  end;
  FSheet := sht;

  AssignFile(rfile, fn);
  reset(rfile);
  ln := 0;
  while not eof(rfile) do begin
	readaline;

	if ln=1 then if st<>'EESchema Schematic File Version 2' then begin
	  Application.MessageBox(PChar('File '+fn+' does not begin with "EEschema schema... version 2"'),'KicadME: error reading sheet');
	  CloseFile(rfile);
	  exit
	end;

	if copy(st, 1, 7)='Title "' then if fmMain.lCurrentTitle.Caption='-' then begin
	  fmMain.lCurrentTitle.Caption := copy(st, 8, length(st)-8);
	  fmMain.lCurrentTitle.Font.Color := clBlack;
	  fmMain.lCurrentFile.Caption  := '('+ExpandFileName(fn)+')';
	  fmMain.lCurrentFile.left := fmMain.lCurrentTitle.left+fmMain.lCurrentTitle.width+12
	end;

	if st='$Comp' then begin
	  // read component
	  repeat
		readaline;
		if st='$EndComp' then break;
		if copy(st,1,2)='L ' then begin
		  // L R R13
		  // but SKIP reference beginning with "#"
		  if pos('#', st)<>0 then begin
			repeat
			  readaline;
			until st='$EndComp';
			break
		  end;
		  new(cmp);
		  cmp^.ps := FComp;
		  FComp := cmp;
		  cmp^.sheetname := sht^.sheetname;
		  delete(st,1,2);
		  i := pos(' ', st);
		  cmp^.part := copy(st, 1, i-1);
		  delete(st,1,i);
		  cmp^.reference := st;
		  cmp^.modified := false;
		end
		else if copy(st,1,5)='F 1 "' then begin
		  // value: F 0 "R13" V 3180 1800 50  0000 C CNN
		  delete(st, 1, 5);
		  i := pos('"', st);
		  delete(st, i, 1000);
		  cmp^.value := st
		end
		else if copy(st,1,5)='F 2 "' then begin
		  // footpr: F 2 "0805" H 3100 1800 60  0001 C CNN
		  delete(st, 1, 5);
		  i := pos('"', st);
		  delete(st, i, 1000);
		  cmp^.Footpr := st
		end
		else if copy(st,1,5)='F 3 "' then begin
		  // footpr: F 3 "" H 3100 1800 60  0001 C CNN
		  delete(st, 1, 5);
		  i := pos('"', st);
		  delete(st, i, 1000);
		  cmp^.userfield := st
		end
	  until false;
	end;

	if st='$Sheet' then begin
	  // read another sheet
	  tmptit := '';		// title for new sheet
	  repeat
		readaline;
		if st='$EndSheet' then break;
		if copy(st,1,4)='F0 "' then begin
		  // sheet name: F0 "Alimentazione" 50
		  delete(st, 1 ,4);
		  i := pos('"', st);
		  tmptit := copy(st, 1, i-1)
		end
		else if copy(st,1,4)='F1 "' then begin
		  // F1 "ALIM.sch" 50
		  delete(st, 1, 4);
		  i := length(st);
		  while st[i]<>'"' do dec(i);
		  setlength(st, i-1);
		  loadsheet(st, tmptit)
		end
	  until false;
	end
  end;

  CloseFile(rfile);

end;


procedure TfmMain.FormShow(Sender: TObject);
begin
  with sgGrid do begin
	cells[0,0] := 'Sheet';
	cells[1,0] := 'Ref';
	cells[2,0] := 'Part';
	cells[3,0] := 'Value';
	cells[4,0] := 'Footpr';
	cells[5,0] := 'Userfld';
  end;
  if ParamStr(1)<>'' then begin
	lCurrentTitle.Caption := '-';
	loadsheet(ParamStr(1), '<root>');
	refreshgrid
  end
end;

// sort comps with bubblesort
procedure sortcomponents;
var
  inverse	: boolean;
  method	: integer;
  cmp1,cmp2	: PKComponent;
  ok		: boolean;
  doswap	: boolean;
  st		: string;

  // tells if cmp2 is less than cmp1
  function compare(cmp1, cmp2: PKComponent): boolean;
  begin
	case method of
	  1: result := cmp2^.sheetname<cmp1^.sheetname;		// sheetname
	  3: result := cmp2^.part<cmp1^.part;
	  4: begin
		// tries to compare values...
		result := cmp2^.value<cmp1^.value;
		end;
	  5: result := cmp2^.Footpr<cmp1^.Footpr;
	  6: result := cmp2^.userfield<cmp1^.userfield;
	  else begin	// reference
		// C9 comes before C10!
		// if pos('#', fmMain.lFRef.text)<>0 then begin
		if length(cmp1^.reference)>length(cmp2^.reference)
		  then result := true
		  else if length(cmp2^.reference)>length(cmp1^.reference)
			then result := false
		    else result := cmp2^.reference<cmp1^.reference;
		end;
	end
  end;


begin
  if FComp=NIL then exit;
  method := SortMethod;
  inverse := SortMethod>10;
  if inverse then dec(method, 10);


  repeat
	ok := true;
	cmp1 := NIL;
	repeat
	  if cmp1=NIL then cmp1 := FComp else cmp1 := cmp1^.ps;
	  if cmp1=NIL then break;

	  if not cmp1^.included then continue;

	  cmp2 := cmp1^.ps;
	  if cmp2=NIL then break;

	  while (cmp2^.ps<>NIL) and not cmp2^.included do cmp2 := cmp2^.ps;
	  if not cmp2^.included then continue;

	  // compare 1 and 2
	  if inverse
		then doswap := compare(cmp2, cmp1)
		else doswap := compare(cmp1, cmp2);

	  if doswap then begin
		// perform swap
		ok := false;
		st := cmp1^.sheetname;	cmp1^.sheetname := cmp2^.sheetname; 	cmp2^.sheetname := st;
		st := cmp1^.reference;	cmp1^.reference := cmp2^.reference; 	cmp2^.reference := st;
		st := cmp1^.part;		cmp1^.part := cmp2^.part; 				cmp2^.part:= st;
		st := cmp1^.value;		cmp1^.value:= cmp2^.value; 				cmp2^.value:= st;
		st := cmp1^.Footpr;		cmp1^.Footpr:= cmp2^.Footpr; 			cmp2^.Footpr:= st;
		st := cmp1^.userfield;	cmp1^.userfield:= cmp2^.userfield; 		cmp2^.userfield := st;
		break
	  end
	until false
  until ok
end;

function match(const st,reg: string): boolean;
var
  i,k		: integer;

label
  ok, Asterisco;

begin
  i := 1;
  k := 1;
  result := false;

  while (i<=length(st)) and (k<=length(reg)) do begin
	if reg[k]='*' then begin
	  {andare al prossimo}
	  inc(k);
	  if k>length(reg) then goto ok;	{asterisco finale - bene}
	  while (i<=length(st)) and (st[i]<>reg[k]) do inc(i);
	  if i>length(st) then exit
	end else if (reg[k]='?') or (reg[k]=st[i]) then begin
	  inc(i);
	  inc(k)
	end else if (reg[k]='#') then begin
	  inc(k);
	  while (i<=length(st)) and (st[i] in ['0'..'9']) do inc(i);
	end else begin

  Asterisco:
	  {se c'era PRIMA un asterisco, allora torna l. Altrimenti fallito}
	  if pos('*',copy(reg,1,k))=0 then exit;
	  if k>length(reg) then dec(k);
	  while reg[k]<>'*' do dec(k)
	end
  end;
  if i<=length(st) then goto asterisco;
  if k<=length(reg) then if (k<length(reg)) or (reg[k]<>'*') then exit;

ok:
  result := true;
end;


procedure TfmMain.RefreshGrid;
var
  cmp	: PKComponent;
  y		: integer;

  function filter(filt, where: string): boolean;
  begin
	result := false;
	if filt='' then exit;

	filt := uppercase(filt);
	where := uppercase(where);

	if pos('?', filt)+pos('*',filt)+pos('#',filt)<>0 then begin
	  // simple pattaern match
	  result := not match(where, filt)
	end else begin
	  // simple check
	  result := 0=pos(filt, where)
	end
  end;


begin

  // filter out unwanted components
  cmp := FComp;
  while cmp<>NIL do begin
	cmp^.included := true;

	// filters: any string; but if it contains "?" or "*", then simplified match
	if filter(lfSheet.text, cmp^.sheetname) then cmp^.included := false;
	if filter(lFRef.text, cmp^.reference) then cmp^.included := false;
	if filter(lFPart.text, cmp^.part) then cmp^.included := false;
	if filter(lfValue.text, cmp^.value) then cmp^.included := false;
	if filter(lfFootpr.text, cmp^.Footpr) then cmp^.included := false;
	if filter(lfUser.text, cmp^.userfield) then cmp^.included := false;

	cmp := cmp^.ps
  end;

  sortcomponents;

  cmp := NIL;
  y := 0;
  repeat
	if cmp=NIL then cmp := FComp else cmp := cmp^.ps;
	if cmp=NIL then break;

	// filter wanted ones...
	if not cmp^.included then continue;

	// ok, display it
	inc(y);
	if sgGrid.RowCount<=y then sgGrid.RowCount := y+8;	// add more than one: it's faster
	with cmp^ do begin
	  sgGrid.Cells[0, y] := sheetname;
	  sgGrid.Cells[1, y] := reference;
	  sgGrid.Cells[2, y] := part;
	  sgGrid.Cells[3, y] := value;
	  sgGrid.Cells[4, y] := Footpr;
	  sgGrid.Cells[5, y] := userfield;
	end
  until false;

  if y=0 then begin
	// no components match!
	sgGrid.RowCount := 2;
	for y := 0 to 5 do sgGrid.cells[y, 1] := '';
	lCompCount.Caption := 'NO COMPONENT matches filter'
  end else begin
	inc(y);
	sgGrid.RowCount := y;
	lCompCount.Caption := inttostr(y)+' matching components.'
  end

end;

procedure TfmMain.lfUserChange(Sender: TObject);
begin
  // when filters are changed
  tmRefresh.Interval := 700;
  tmRefresh.Enabled := true;
  lCopyFrom.Visible := false
end;

procedure TfmMain.tmRefreshTimer(Sender: TObject);
begin
  tmRefresh.Enabled := false;
  RefreshGrid
end;

procedure TfmMain.SpeedButton12Click(Sender: TObject);
begin
  sortmethod := TSpeedButton(sender).Tag;
  RefreshGrid;
  with sgGrid do edEdit.Text := cells[col,row];
end;

procedure TfmMain.sgGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
var
  savx,savy	: integer;

begin
  if acol<3 then begin
	edEdit.visible := false;
	Label8.Caption := 'This grid column is read-only.';
  end else begin
	edEdit.visible := true;
	Label8.Caption := '<-- Write new text here then press ENTER';
  end;
  edEdit.Text := sgGrid.Cells[acol, arow];
  if lCopyFrom.Visible then begin
	copytext := edEdit.Text;
	// lCopyFrom.Visible := false
  end
end;

procedure TfmMain.edEditKeyPress(Sender: TObject; var Key: Char);
var
  i		: integer;
  cmp	: PKComponent;

begin
  if key<>#13 then exit;
  with sgGrid.Selection do begin
	// mmLog.Lines.Add('x1='+inttostr(Left)+' y1='+IntToStr(Top)+' x2='+inttostr(Right)+' y2='+inttostr(Bottom))
	if left<>right then begin
	  Application.MessageBox('Selected cells must be all in the same column.', 'KiCadME');
	  exit
	end;
	if left<3 then begin
	  Application.MessageBox('The first THREE columns are read-only', 'KiCadME');
	  exit
	end;
	for i := top to bottom do begin
	  sgGrid.cells[left, i] := edEdit.text;
	  cmp := FComp;
	  while cmp<>NIL do begin
		if cmp^.reference=sgGrid.Cells[1, i] then begin
		  case left of
			3: cmp^.value := edEdit.text;
			4: cmp^.Footpr := edEdit.text;
			5: cmp^.userfield := edEdit.text;
		  end;
		  cmp^.modified := true;
		  break
		end;
		cmp := cmp^.ps
	  end
	end;
	mmLog.Lines.Add('Wrote "'+edEdit.text+'" in '+inttostr(bottom-top+1)+' components.');
	fmMain.lCurrentTitle.Font.Color := clRed
  end
end;

procedure TfmMain.Open1Click(Sender: TObject);
begin
  if not dlgOpen.Execute then exit;
  if fmMain.lCurrentTitle.Font.Color=clRed then begin
	if Application.MessageBox('There are modifications pending. Sure to load another schema?', 'KiCadME', MB_YESNO)<>IDYES then exit;
	if Application.MessageBox('Really don''t want to save first?', 'KiCadME', MB_YESNO)<>IDNO then exit
  end;

  lCurrentTitle.Caption := '-';
  loadsheet(dlgOpen.FileName, '<root>');
  refreshgrid
end;

procedure TfmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  canclose := false;
  if fmMain.lCurrentTitle.Font.Color=clRed then begin
	if Application.MessageBox('There are modifications pending. Sure to continue?', 'KiCadME', MB_YESNO)<>IDYES then exit;
	if Application.MessageBox('Do you want to save first?', 'KiCadME', MB_YESNO)<>IDNO then exit
  end;
  canclose := true
end;

procedure TfmMain.Exit1Click(Sender: TObject);
begin
  close
end;

procedure TfmMain.lFSheetKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if key=VK_UP then sgGrid.SetFocus;
  if key=VK_DOWN then sgGrid.SetFocus;
end;

procedure TfmMain.Save1Click(Sender: TObject);
var
  rfile,ofile	: TextFile;
  st, ost		: string;
  tmptit	: string;
  i,k		: integer;
  sht		: PKSheet;
  cmp		: PKComponent;

  procedure readaline;
  begin
	if ost<>#0 then writeln(ofile, ost);
	readln(rfile, st);
	ost := st;
  end;

begin
  if fmMain.lCurrentTitle.Font.Color<>clRed then exit;

  cmp := FComp;
  while cmp<>NIL do begin
	if cmp^.modified then begin
	  sht := FSheet;
	  while (sht<>NIL) and (sht^.sheetname<>cmp^.sheetname) do sht := sht^.ps;
	  if sht<>NIL then sht^.modified := true
	end;
	cmp := cmp^.ps
  end;

  sht := FSheet;
  while sht<>nil do begin
	if not sht^.modified then begin
	  sht := sht^.ps;
	  continue
	end;

	st := sht^.filename+'.kmesav';
	if FileExists(st)
	  then DeleteFile(st);

	RenameFile(sht^.filename, st);

	AssignFile(rfile, st);
	reset(rfile);

	AssignFile(ofile, sht^.filename);
	rewrite(ofile);
	ost := #0;

	mmLog.Lines.Add('Updating file '+sht^.filename);

	while not eof(rfile) do begin
	  readaline;

	  if st='$Comp' then begin
		// update component
		cmp := NIL;
		repeat
		  readaline;
		  if st='$EndComp' then break;
		  if copy(st,1,2)='L ' then begin
			// L R R13
			delete(st,1,2);
			i := pos(' ', st);
			delete(st,1,i);
			// now reference is in st, search component
			if pos('#', st)<>0 then break;		// internal comp, pass to the next
			cmp := FComp;
			while cmp<>NIL do begin
			  if cmp^.reference=st then break;
			  cmp := cmp^.ps
			end;
			if cmp=NIL then begin
			  Application.MessageBox(PChar('Warning - internal error - can not find component '+st), 'KiCadME');
			  break
			end;
			if not cmp^.modified then break;
		  end
		  else if copy(st,1,5)='F 1 "' then begin
			// value: F 0 "R13" V 3180 1800 50  0000 C CNN
			ost := copy(st, 1, 5)+cmp^.value+'"';
			delete(st, 1, 5);
			i := pos('"', st);
			delete(st, 1, i);
			ost := ost+st
		  end
		  else if copy(st,1,5)='F 2 "' then begin
			// footpr: F 2 "0805" H 3100 1800 60  0001 C CNN
			ost := copy(st, 1, 5)+cmp^.Footpr+'"';
			delete(st, 1, 5);
			i := pos('"', st);
			if (i=1) or ckFPInvisible.Checked then begin
			  // field was invisible, or we want it invisible now
			  delete(st, 1, i);
			  ost := ost+st;
			  if cmp^.Footpr<>'' then if pos(' 0000 C CNN', ost)<>0 then begin
				// but now it is, we don't want
				i := pos(' 0000 C CNN', ost);
				ost[i+4] := '1'
			  end
			end else begin
			  // field was already visible, nothing to change
			  delete(st, 1, i);
			  ost := ost+st
			end
		  end
		  else if copy(st,1,5)='F 3 "' then begin
			// user: F 3 "" H 3100 1800 60  0001 C CNN
			ost := copy(st, 1, 5)+cmp^.userfield+'"';
			delete(st, 1, 5);
			i := pos('"', st);
			delete(st, 1, i);
			ost := ost+st
		  end
		until false;
	  end;	// for a component

	end;	// for this file

	writeln(ofile, ost);
	CloseFile(ofile);
	Closefile(rfile);

	sht := sht^.ps
  end;

  fmMain.lCurrentTitle.Font.Color := clBlack;
  mmLog.Lines.Add('Modifications saved.')

end;

procedure TfmMain.sgGridKeyPress(Sender: TObject; var Key: Char);
begin
  // sgGrid.SetFocus
  if not edEdit.Visible then exit;
  edEdit.SelectAll;
  edEdit.SetFocus;
  PostMessage(edEdit.handle, WM_CHAR, ord(key), 0);
end;

procedure TfmMain.Selecteditcell1Click(Sender: TObject);
begin
  if edEdit.Enabled and edEdit.Visible then edEdit.SetFocus
end;

procedure TfmMain.Copyfieldfrom1Click(Sender: TObject);
begin
  copycol := sgGrid.Col;
  copyrow := sgGrid.Row;
  copysel := sgGrid.Selection;

  // copyfrom := true;
  lCopyFrom.Visible := true
end;



procedure TfmMain.sgGridMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  ch	: char;
  mtext	: string;

begin
  if lCopyFrom.Visible then begin
	mtext := copytext;
	sgGrid.col := copycol;
	sgGrid.Row := copyrow;
	sgGrid.Selection := copysel;
	edEdit.Text := mtext;
	ch := #13;
	edEdit.OnKeyPress(NIL, ch);
	lCopyFrom.Visible := false
  end

end;

procedure TfmMain.Cancelcopyfrom1Click(Sender: TObject);
begin
  lCopyFrom.Visible := false
end;

procedure TfmMain.lFSheetEnter(Sender: TObject);
begin
  lCopyFrom.Visible := false
end;

procedure TfmMain.Label1DblClick(Sender: TObject);
begin
  lFSheet.Text := ''
end;

procedure TfmMain.Label2DblClick(Sender: TObject);
begin
  lFRef.Text := ''
end;

procedure TfmMain.Label3DblClick(Sender: TObject);
begin
  lFPart.Text := ''
end;

procedure TfmMain.Label4DblClick(Sender: TObject);
begin
  lfValue.Text := ''
end;

procedure TfmMain.Label5DblClick(Sender: TObject);
begin
  lfFootpr.Text := ''
end;

procedure TfmMain.Label6DblClick(Sender: TObject);
begin
  lfUser.Text := ''
end;

procedure TfmMain.About1Click(Sender: TObject);
begin
  fmAbout.show
end;

end.
